<?php

require_once( dirname(__FILE__)."/QRInformation.php" );

class CQRDataElement
{
	protected $m_iDataMode = -1;
    public function GetDataMode()
    {
        return $this->m_iDataMode;
    }
	protected $m_iDataLength = 0;
    public function GetDataLength()
    {
        return $this->m_iDataLength;
    }
    protected $m_pszData = "";
    public function GetData()
    {
        return $this->m_pszData;
    }
    
    public function __constructor( $qrElement = NULL )
    {
        $this->InitData();
        if( $qrElement != NULL )
        {
            $this->SetData( $qrElement->m_pszData, $qrElement->m_iDataLength, $qrElement->m_iDataMode );
        }
    }

	public function SetData( $pcszString , $iDataLength, $iDataMode )
    {
        if( $pcszString != NULL && $iDataLength != 0 )
        {
            $this->m_pszData = "";
            $this->m_iDataMode = $iDataMode;
            $this->AddData( $pcszString, $iDataLength, $iDataMode );
        }
    }
    
	public function AddData( $pcszString , $iDataLength, $iDataMode )
    {
        if( $pcszString == NULL || $iDataLength == 0 || $this->m_iDataMode != $iDataMode )
        {
            return FALSE;
        }
        
        //$iDataLengthで出力データを絞っている場合を考えて、substrによる追加を行う
        $this->m_pszData .= substr( $pcszString, 0, $iDataLength );
        $this->m_iDataLength += $iDataLength;
        
        return TRUE;
    }

	protected function InitData()
    {
        $this->m_iDataMode = -1;
        $this->m_iDataLength = 0;
        $this->m_pszData = "";
    }
}
?>