<?php

const QRCHARACTERTYPE_UNKNOWN    =   -1;
const QRCHARACTERTYPE_NUMERIC    =   1;
const QRCHARACTERTYPE_ALPHABET   =   2;
const QRCHARACTERTYPE_ASCII		=   3;
const QRCHARACTERTYPE_KANJI      =   4;

const QRDATA_LAST                =   4;

const COLLECTLEVEL_L=0x01;
const COLLECTLEVEL_M=0x00;
const COLLECTLEVEL_Q=0x03;
const COLLECTLEVEL_H=0x02;

//QR作成時、エラー番号
const QRERR_NOERROR=0;
const QRERR_WRONG_COLLECTTYPE=1;
const QRERR_DATASIZE_LARGE=2;
const QRERR_DONTSET_TYPENUMBER=3;
const QRERR_DATAISNOT_NUMERIC=4;
const QRERR_DATAISNOT_ALPHA=5;
const QRERR_DATAISNOT_KANJI=6;
const QRERR_WRONGDIRECT_BIT=7;
const QRERR_DATABITCOUNT_FAILURE=8;

//QRコードの各パターン
const QR_UNKNOWN=-1;
const QR_DATA_LIGHT=0;
const QR_DATA_DARK=1;
const QR_COLLECT_LIGHT=2;
const QR_COLLECT_DARK=3;
const QR_POSITIONDITECT_LIGHT=10;
const QR_POSITIONDITECT_DARK=11;
const QR_POSITIONCHECK_LIGHT=12;
const QR_POSITIONCHECK_DARK=13;
const QR_TIMING_LIGHT=14;
const QR_TIMING_DARK=15;
const QR_TYPE_LIGHT=20;
const QR_TYPE_DARK=21;
const QR_MODEL_LIGHT=22;
const QR_MODEL_DARK=23;

const QR_MASK_LIGHT=50;
const QR_MASK_DARK=51;

const QR_BIT_0=0x01;
const QR_BIT_1=0x02;
const QR_BIT_2=0x04;
const QR_BIT_3=0x08;
const QR_BIT_4=0x10;
const QR_BIT_5=0x20;
const QR_BIT_6=0x40;
const QR_BIT_7=0x80;

$ucBits = array( QR_BIT_7, QR_BIT_6, QR_BIT_5, QR_BIT_4,
                 QR_BIT_3, QR_BIT_2, QR_BIT_1, QR_BIT_0 );
				

/*struct STypeMatrix
{
	int m_iModelNumber;		//型番
	int m_iCollectLevel;	//エラー訂正レベル
	int m_iDataBitNumber;	//データビット数
	int m_iTotalBits;		//総コードビット数
	int m_iRSBlockNumber;	//ＲＳブロック数
};*/

function createSTypeMatrix( $iModelNumber, $iCollectLevel, $iDataBitNumber, $iTotalBits, $iRSBlockNumber )
{
    $element = new stdClass;
    $element->m_iModelNumber = $iModelNumber;
    $element->m_iCollectLevel = $iCollectLevel;
    $element->m_iDataBitNumber = $iDataBitNumber;
    $element->m_iTotalBits = $iTotalBits;
    $element->m_iRSBlockNumber = $iRSBlockNumber;
    
    return $element;
}
//型番・エラー訂正レベルに対する表現可能データ数配列
$c_typeMatrix = array(
    createSTypeMatrix(  1, COLLECTLEVEL_L,   152,   208 ,  1 ),
    createSTypeMatrix(  1, COLLECTLEVEL_M,   128,   208 ,  1 ),
    createSTypeMatrix(  1, COLLECTLEVEL_Q,   104,   208 ,  1 ),
    createSTypeMatrix(  1, COLLECTLEVEL_H,    72,   208 ,  1 ),
    createSTypeMatrix(  2, COLLECTLEVEL_L,   272,   352 ,  1 ),
    createSTypeMatrix(  2, COLLECTLEVEL_M,   224,   352 ,  1 ),
    createSTypeMatrix(  2, COLLECTLEVEL_Q,   176,   352 ,  1 ),
    createSTypeMatrix(  2, COLLECTLEVEL_H,   128,   352 ,  1 ),
    createSTypeMatrix(  3, COLLECTLEVEL_L,   440,   560 ,  1 ),
    createSTypeMatrix(  3, COLLECTLEVEL_M,   352,   560 ,  1 ),
    createSTypeMatrix(  3, COLLECTLEVEL_Q,   272,   560 ,  2 ),
    createSTypeMatrix(  3, COLLECTLEVEL_H,   208,   560 ,  2 ),
    createSTypeMatrix(  4, COLLECTLEVEL_L,   640,   800 ,  1 ),
    createSTypeMatrix(  4, COLLECTLEVEL_M,   512,   800 ,  2 ),
    createSTypeMatrix(  4, COLLECTLEVEL_Q,   384,   800 ,  2 ),
    createSTypeMatrix(  4, COLLECTLEVEL_H,   288,   800 ,  4 ),
    createSTypeMatrix(  5, COLLECTLEVEL_L,   864,  1072 ,  1 ),
    createSTypeMatrix(  5, COLLECTLEVEL_M,   688,  1072 ,  2 ),
    createSTypeMatrix(  5, COLLECTLEVEL_Q,   496,  1072 ,  4 ),
    createSTypeMatrix(  5, COLLECTLEVEL_H,   368,  1072 ,  4 ),
    createSTypeMatrix(  6, COLLECTLEVEL_L,  1088,  1376 ,  2 ),
    createSTypeMatrix(  6, COLLECTLEVEL_M,   864,  1376 ,  4 ),
    createSTypeMatrix(  6, COLLECTLEVEL_Q,   608,  1376 ,  4 ),
    createSTypeMatrix(  6, COLLECTLEVEL_H,   480,  1376 ,  4 ),
    createSTypeMatrix(  7, COLLECTLEVEL_L,  1248,  1568 ,  2 ),
    createSTypeMatrix(  7, COLLECTLEVEL_M,   992,  1568 ,  4 ),
    createSTypeMatrix(  7, COLLECTLEVEL_Q,   704,  1568 ,  6 ),
    createSTypeMatrix(  7, COLLECTLEVEL_H,   528,  1568 ,  5 ),
    createSTypeMatrix(  8, COLLECTLEVEL_L,  1552,  1936 ,  2 ),
    createSTypeMatrix(  8, COLLECTLEVEL_M,  1232,  1936 ,  4 ),
    createSTypeMatrix(  8, COLLECTLEVEL_Q,   880,  1936 ,  6 ),
    createSTypeMatrix(  8, COLLECTLEVEL_H,   688,  1936 ,  6 ),
    createSTypeMatrix(  9, COLLECTLEVEL_L,  1856,  2336 ,  2 ),
    createSTypeMatrix(  9, COLLECTLEVEL_M,  1456,  2336 ,  5 ),
    createSTypeMatrix(  9, COLLECTLEVEL_Q,  1056,  2336 ,  8 ),
    createSTypeMatrix(  9, COLLECTLEVEL_H,   800,  2336 ,  8 ),
    createSTypeMatrix( 10, COLLECTLEVEL_L,  2192,  2768 ,  4 ),
    createSTypeMatrix( 10, COLLECTLEVEL_M,  1728,  2768 ,  5 ),
    createSTypeMatrix( 10, COLLECTLEVEL_Q,  1232,  2768 ,  8 ),
    createSTypeMatrix( 10, COLLECTLEVEL_H,   976,  2768 ,  8 ),
    createSTypeMatrix( 11, COLLECTLEVEL_L,  2592,  3232 ,  4 ),
    createSTypeMatrix( 11, COLLECTLEVEL_M,  2032,  3232 ,  5 ),
    createSTypeMatrix( 11, COLLECTLEVEL_Q,  1440,  3232 ,  8 ),
    createSTypeMatrix( 11, COLLECTLEVEL_H,  1120,  3232 , 11 ),
    createSTypeMatrix( 12, COLLECTLEVEL_L,  2960,  3728 ,  4 ),
    createSTypeMatrix( 12, COLLECTLEVEL_M,  2320,  3728 ,  8 ),
    createSTypeMatrix( 12, COLLECTLEVEL_Q,  1648,  3728 , 10 ),
    createSTypeMatrix( 12, COLLECTLEVEL_H,  1264,  3728 , 11 ),
    createSTypeMatrix( 13, COLLECTLEVEL_L,  3424,  4256 ,  4 ),
    createSTypeMatrix( 13, COLLECTLEVEL_M,  2672,  4256 ,  9 ),
    createSTypeMatrix( 13, COLLECTLEVEL_Q,  1952,  4256 , 12 ),
    createSTypeMatrix( 13, COLLECTLEVEL_H,  1440,  4256 , 16 ),
    createSTypeMatrix( 14, COLLECTLEVEL_L,  3688,  4648 ,  4 ),
    createSTypeMatrix( 14, COLLECTLEVEL_M,  2920,  4648 ,  9 ),
    createSTypeMatrix( 14, COLLECTLEVEL_Q,  2088,  4648 , 16 ),
    createSTypeMatrix( 14, COLLECTLEVEL_H,  1576,  4648 , 16 ),
    createSTypeMatrix( 15, COLLECTLEVEL_L,  4184,  5240 ,  6 ),
    createSTypeMatrix( 15, COLLECTLEVEL_M,  3320,  5240 , 10 ),
    createSTypeMatrix( 15, COLLECTLEVEL_Q,  2360,  5240 , 12 ),
    createSTypeMatrix( 15, COLLECTLEVEL_H,  1784,  5240 , 18 ),
    createSTypeMatrix( 16, COLLECTLEVEL_L,  4712,  5864 ,  6 ),
    createSTypeMatrix( 16, COLLECTLEVEL_M,  3624,  5864 , 10 ),
    createSTypeMatrix( 16, COLLECTLEVEL_Q,  2600,  5864 , 17 ),
    createSTypeMatrix( 16, COLLECTLEVEL_H,  2024,  5864 , 16 ),
    createSTypeMatrix( 17, COLLECTLEVEL_L,  5176,  6520 ,  6 ),
    createSTypeMatrix( 17, COLLECTLEVEL_M,  4056,  6520 , 11 ),
    createSTypeMatrix( 17, COLLECTLEVEL_Q,  2936,  6520 , 16 ),
    createSTypeMatrix( 17, COLLECTLEVEL_H,  2264,  6520 , 19 ),
    createSTypeMatrix( 18, COLLECTLEVEL_L,  5768,  7208 ,  6 ),
    createSTypeMatrix( 18, COLLECTLEVEL_M,  4504,  7208 , 13 ),
    createSTypeMatrix( 18, COLLECTLEVEL_Q,  3176,  7208 , 18 ),
    createSTypeMatrix( 18, COLLECTLEVEL_H,  2504,  7208 , 21 ),
    createSTypeMatrix( 19, COLLECTLEVEL_L,  6360,  7928 ,  7 ),
    createSTypeMatrix( 19, COLLECTLEVEL_M,  5016,  7928 , 14 ),
    createSTypeMatrix( 19, COLLECTLEVEL_Q,  3560,  7928 , 21 ),
    createSTypeMatrix( 19, COLLECTLEVEL_H,  2728,  7928 , 25 ),
    createSTypeMatrix( 20, COLLECTLEVEL_L,  6888,  8680 ,  8 ),
    createSTypeMatrix( 20, COLLECTLEVEL_M,  5352,  8680 , 16 ),
    createSTypeMatrix( 20, COLLECTLEVEL_Q,  3880,  8680 , 20 ),
    createSTypeMatrix( 20, COLLECTLEVEL_H,  3080,  8680 , 25 ),
    createSTypeMatrix( 21, COLLECTLEVEL_L,  7456,  9248 ,  8 ),
    createSTypeMatrix( 21, COLLECTLEVEL_M,  5712,  9248 , 17 ),
    createSTypeMatrix( 21, COLLECTLEVEL_Q,  4096,  9248 , 23 ),
    createSTypeMatrix( 21, COLLECTLEVEL_H,  3248,  9248 , 25 ),
    createSTypeMatrix( 22, COLLECTLEVEL_L,  8048, 10064 ,  9 ),
    createSTypeMatrix( 22, COLLECTLEVEL_M,  6256, 10064 , 17 ),
    createSTypeMatrix( 22, COLLECTLEVEL_Q,  4544, 10064 , 23 ),
    createSTypeMatrix( 22, COLLECTLEVEL_H,  3536, 10064 , 34 ),
    createSTypeMatrix( 23, COLLECTLEVEL_L,  8752, 10912 ,  9 ),
    createSTypeMatrix( 23, COLLECTLEVEL_M,  6880, 10912 , 18 ),
    createSTypeMatrix( 23, COLLECTLEVEL_Q,  4912, 10912 , 25 ),
    createSTypeMatrix( 23, COLLECTLEVEL_H,  3712, 10912 , 30 ),
    createSTypeMatrix( 24, COLLECTLEVEL_L,  9392, 11792 , 10 ),
    createSTypeMatrix( 24, COLLECTLEVEL_M,  7312, 11792 , 20 ),
    createSTypeMatrix( 24, COLLECTLEVEL_Q,  5312, 11792 , 27 ),
    createSTypeMatrix( 24, COLLECTLEVEL_H,  4112, 11792 , 32 ),
    createSTypeMatrix( 25, COLLECTLEVEL_L, 10208, 12704 , 12 ),
    createSTypeMatrix( 25, COLLECTLEVEL_M,  8000, 12704 , 21 ),
    createSTypeMatrix( 25, COLLECTLEVEL_Q,  5744, 12704 , 29 ),
    createSTypeMatrix( 25, COLLECTLEVEL_H,  4304, 12704 , 35 ),
    createSTypeMatrix( 26, COLLECTLEVEL_L, 10960, 13648 , 12 ),
    createSTypeMatrix( 26, COLLECTLEVEL_M,  8496, 13648 , 23 ),
    createSTypeMatrix( 26, COLLECTLEVEL_Q,  6032, 13648 , 34 ),
    createSTypeMatrix( 26, COLLECTLEVEL_H,  4768, 13648 , 37 ),
    createSTypeMatrix( 27, COLLECTLEVEL_L, 11744, 14624 , 12 ),
    createSTypeMatrix( 27, COLLECTLEVEL_M,  9024, 14624 , 25 ),
    createSTypeMatrix( 27, COLLECTLEVEL_Q,  6464, 14624 , 34 ),
    createSTypeMatrix( 27, COLLECTLEVEL_H,  5024, 14624 , 40 ),
    createSTypeMatrix( 28, COLLECTLEVEL_L, 12248, 15368 , 13 ),
    createSTypeMatrix( 28, COLLECTLEVEL_M,  9544, 15368 , 26 ),
    createSTypeMatrix( 28, COLLECTLEVEL_Q,  6968, 15368 , 35 ),
    createSTypeMatrix( 28, COLLECTLEVEL_H,  5288, 15368 , 42 ),
    createSTypeMatrix( 29, COLLECTLEVEL_L, 13048, 16408 , 14 ),
    createSTypeMatrix( 29, COLLECTLEVEL_M, 10136, 16408 , 28 ),
    createSTypeMatrix( 29, COLLECTLEVEL_Q,  7288, 16408 , 38 ),
    createSTypeMatrix( 29, COLLECTLEVEL_H,  5608, 16408 , 45 ),
    createSTypeMatrix( 30, COLLECTLEVEL_L, 13880, 17480 , 15 ),
    createSTypeMatrix( 30, COLLECTLEVEL_M, 10984, 17480 , 29 ),
    createSTypeMatrix( 30, COLLECTLEVEL_Q,  7880, 17480 , 40 ),
    createSTypeMatrix( 30, COLLECTLEVEL_H,  5960, 17480 , 48 ),
    createSTypeMatrix( 31, COLLECTLEVEL_L, 14744, 18584 , 16 ),
    createSTypeMatrix( 31, COLLECTLEVEL_M, 11640, 18584 , 31 ),
    createSTypeMatrix( 31, COLLECTLEVEL_Q,  8264, 18584 , 43 ),
    createSTypeMatrix( 31, COLLECTLEVEL_H,  6344, 18584 , 51 ),
    createSTypeMatrix( 32, COLLECTLEVEL_L, 15640, 19720 , 17 ),
    createSTypeMatrix( 32, COLLECTLEVEL_M, 12328, 19720 , 33 ),
    createSTypeMatrix( 32, COLLECTLEVEL_Q,  8920, 19720 , 45 ),
    createSTypeMatrix( 32, COLLECTLEVEL_H,  6760, 19720 , 54 ),
    createSTypeMatrix( 33, COLLECTLEVEL_L, 16568, 20888 , 18 ),
    createSTypeMatrix( 33, COLLECTLEVEL_M, 13048, 20888 , 35 ),
    createSTypeMatrix( 33, COLLECTLEVEL_Q,  9368, 20888 , 48 ),
    createSTypeMatrix( 33, COLLECTLEVEL_H,  7208, 20888 , 57 ),
    createSTypeMatrix( 34, COLLECTLEVEL_L, 17528, 22088 , 19 ),
    createSTypeMatrix( 34, COLLECTLEVEL_M, 13800, 22088 , 37 ),
    createSTypeMatrix( 34, COLLECTLEVEL_Q,  9848, 22088 , 51 ),
    createSTypeMatrix( 34, COLLECTLEVEL_H,  7688, 22088 , 60 ),
    createSTypeMatrix( 35, COLLECTLEVEL_L, 18448, 23008 , 19 ),
    createSTypeMatrix( 35, COLLECTLEVEL_M, 14496, 23008 , 38 ),
    createSTypeMatrix( 35, COLLECTLEVEL_Q, 10288, 23008 , 53 ),
    createSTypeMatrix( 35, COLLECTLEVEL_H,  7888, 23008 , 63 ),
    createSTypeMatrix( 36, COLLECTLEVEL_L, 19472, 24272 , 20 ),
    createSTypeMatrix( 36, COLLECTLEVEL_M, 15312, 24272 , 40 ),
    createSTypeMatrix( 36, COLLECTLEVEL_Q, 10832, 24272 , 56 ),
    createSTypeMatrix( 36, COLLECTLEVEL_H,  8432, 24272 , 66 ),
    createSTypeMatrix( 37, COLLECTLEVEL_L, 20528, 25568 , 21 ),
    createSTypeMatrix( 37, COLLECTLEVEL_M, 15936, 25568 , 43 ),
    createSTypeMatrix( 37, COLLECTLEVEL_Q, 11408, 25568 , 59 ),
    createSTypeMatrix( 37, COLLECTLEVEL_H,  8768, 25568 , 70 ),
    createSTypeMatrix( 38, COLLECTLEVEL_L, 21616, 26896 , 22 ),
    createSTypeMatrix( 38, COLLECTLEVEL_M, 16816, 26896 , 45 ),
    createSTypeMatrix( 38, COLLECTLEVEL_Q, 12016, 26896 , 62 ),
    createSTypeMatrix( 38, COLLECTLEVEL_H,  9136, 26896 , 74 ),
    createSTypeMatrix( 39, COLLECTLEVEL_L, 22496, 28256 , 24 ),
    createSTypeMatrix( 39, COLLECTLEVEL_M, 17728, 28256 , 47 ),
    createSTypeMatrix( 39, COLLECTLEVEL_Q, 12656, 28256 , 65 ),
    createSTypeMatrix( 39, COLLECTLEVEL_H,  9776, 28256 , 77 ),
    createSTypeMatrix( 40, COLLECTLEVEL_L, 23648, 29648 , 25 ),
    createSTypeMatrix( 40, COLLECTLEVEL_M, 18672, 29648 , 49 ),
    createSTypeMatrix( 40, COLLECTLEVEL_Q, 13328, 29648 , 68 ),
    createSTypeMatrix( 40, COLLECTLEVEL_H, 10208, 29648 , 81 ),
    createSTypeMatrix( -1,             -1,     0,     0 ,  0 )	//終端データ
);

//位置あわせパターン列
$c_sPositionChecks = array();
    
$c_sPositionChecks[] = array(0,0,0,0,0,0,0,0);
$c_sPositionChecks[] = array(6,18,0,0,0,0,0,0);
$c_sPositionChecks[] = array(6,22,0,0,0,0,0,0);
$c_sPositionChecks[] = array(6,26,0,0,0,0,0,0);
$c_sPositionChecks[] = array(6,30,0,0,0,0,0,0);
$c_sPositionChecks[] = array(6,34,0,0,0,0,0,0);
$c_sPositionChecks[] = array(6,22,38,0,0,0,0,0);
$c_sPositionChecks[] = array(6,24,42,0,0,0,0,0);
$c_sPositionChecks[] = array(6,26,46,0,0,0,0,0);
$c_sPositionChecks[] = array(6,28,50,0,0,0,0,0);
$c_sPositionChecks[] = array(6,30,54,0,0,0,0,0);
$c_sPositionChecks[] = array(6,32,58,0,0,0,0,0);
$c_sPositionChecks[] = array(6,34,62,0,0,0,0,0);
$c_sPositionChecks[] = array(6,26,46,66,0,0,0,0);
$c_sPositionChecks[] = array(6,26,48,70,0,0,0,0);
$c_sPositionChecks[] = array(6,26,50,74,0,0,0,0);
$c_sPositionChecks[] = array(6,30,54,78,0,0,0,0);
$c_sPositionChecks[] = array(6,30,56,82,0,0,0,0);
$c_sPositionChecks[] = array(6,30,58,86,0,0,0,0);
$c_sPositionChecks[] = array(6,34,62,90,0,0,0,0);
$c_sPositionChecks[] = array(6,28,50,72,94,0,0,0);
$c_sPositionChecks[] = array(6,26,50,74,98,0,0,0);
$c_sPositionChecks[] = array(6,30,54,78,102,0,0,0);
$c_sPositionChecks[] = array(6,28,54,80,106,0,0,0);
$c_sPositionChecks[] = array(6,32,58,84,110,0,0,0);
$c_sPositionChecks[] = array(6,30,58,86,114,0,0,0);
$c_sPositionChecks[] = array(6,34,62,90,118,0,0,0);
$c_sPositionChecks[] = array(6,26,50,74,98,122,0,0);
$c_sPositionChecks[] = array(6,30,54,78,102,126,0,0);
$c_sPositionChecks[] = array(6,26,52,78,104,130,0,0);
$c_sPositionChecks[] = array(6,30,56,82,108,134,0,0);
$c_sPositionChecks[] = array(6,34,60,86,112,138,0,0);
$c_sPositionChecks[] = array(6,30,58,86,114,142,0,0);
$c_sPositionChecks[] = array(6,34,62,90,118,146,0,0);
$c_sPositionChecks[] = array(6,30,54,78,102,126,150,0);
$c_sPositionChecks[] = array(6,24,50,76,102,128,154,0);
$c_sPositionChecks[] = array(6,28,54,80,106,132,158,0);
$c_sPositionChecks[] = array(6,32,58,84,110,136,162,0);
$c_sPositionChecks[] = array(6,26,54,82,110,138,166,0);
$c_sPositionChecks[] = array(6,30,58,86,114,142,170,0);

const cszQrAlphabets = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ $%*+-./;";

?>
