<!doctype html>
<html>
    <head>
        <meta charset="utf-8">
        <title>QRテスト</title>
    </head>
    <body>
        <?php
        require_once( dirname(__FILE__)."/../QRInformation.php" );
        require_once( dirname(__FILE__)."/../QRMatrix.php" );
        
        $qrMatrix = new CQRMatrix();
        $qrMatrix->AddQRCharacters( "0123456" , QRCHARACTERTYPE_NUMERIC );
        $qrMatrix->AddQRCharacters( "ABCDEFG" , QRCHARACTERTYPE_ALPHABET );
        $qrMatrix->AddQRCharacters( "http://www.spoonsoftware.com" , QRCHARACTERTYPE_ASCII );

        $kanji = mb_convert_encoding( "★☆★　ＱＲテストパターン　★☆★", "SJIS", "UTF-8" );
        $qrMatrix->AddQRCharacters( $kanji , QRCHARACTERTYPE_KANJI );
        
        
        $iErrorType = 0;
        if( !$qrMatrix->MakeQRMatrix( COLLECTLEVEL_M, $iErrorType ) )
        {
            print "Error occured! Error type is ".$iErrorType;
        }
        else
        {
            //行・列のデータをチェックして出力
            for( $iRowIndex = 0 ; $iRowIndex < $qrMatrix->GetModuleNumber() ; $iRowIndex++ )
            {
                for( $iColumnIndex = 0 ; $iColumnIndex < $qrMatrix->GetModuleNumber() ; $iColumnIndex++ )
                {
                    if( $qrMatrix->IsDarkPoint( $iColumnIndex , $iRowIndex ) )
                    {
                        print "■";
                    }
                    else
                    {
                        print  "□";
                    }
                }
                print "<br>";
            }
        }
        ?>
    </body>
</html>